/*

Copyright 2019, dettus@dettus.net

Redistribution and use in source and binary forms, with or without modification,
are permitted provided that the following conditions are met:

1. Redistributions of source code must retain the above copyright notice, this 
   list of conditions and the following disclaimer.

2. Redistributions in binary form must reproduce the above copyright notice, 
   this list of conditions and the following disclaimer in the documentation 
   and/or other materials provided with the distribution.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED 
WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE 
DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE 
FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL 
DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR 
SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER 
CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, 
OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE 
OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.


*/

#include <stdio.h>
#include <stdlib.h>
#include "default_render.h"
#include "picture.h"
int default_render_lowansi(tPicture* picture,int rows,int cols)
{
	int i;
	int j;
	int k,l;

	int y_up,y_down,x_left,x_right;
	int accux,accuy;
	int cnt,cnt2;
	int red,green,blue;
	int p;
	int col;
	char c;
//	const char similar[17]="0123\\5|7=9\%bcdef@";
	const char similar[16]="@1=3\\5|789ab@def";
//	const char similar[16]="@1|3=5\%789ab@def";
	accux=accuy=0;
	int redcorr,greencorr,bluecorr;
	
	y_up=0;
	c='$';
	redcorr=0;
	greencorr=0;
	bluecorr=0;
	for (i=0;i<16;i++)
	{
		redcorr+=(picture->palette[i]>>8)&0xf;
		greencorr+=(picture->palette[i]>>4)&0xf;
		bluecorr+=(picture->palette[i]>>0)&0xf;
	}
	//cnt=(picture->height*picture->width)/(rows*cols);
	cnt=4;
	// TODO: WHY DO THE PICTURES LOOK GOOD WITH THOSE PARTICULAR CORRECTION VALUES??
// the pawn
	if (redcorr==54 && greencorr==60 && bluecorr==48) {redcorr=2;greencorr=2;bluecorr=1;}
	else if (redcorr==63 && greencorr==60 && bluecorr==50) {redcorr=3;greencorr=3;bluecorr=2;}
	else if (redcorr==43 && greencorr==43 && bluecorr==38) {redcorr=-1;greencorr=-1;bluecorr=-1;}
	else if (redcorr==64 && greencorr==36 && bluecorr==16) {redcorr=1;greencorr=1;bluecorr=0;}
	else if (redcorr==46 && greencorr==61 && bluecorr==35) {redcorr=1;greencorr=2;bluecorr=1;}
	else if (redcorr==46 && greencorr==54 && bluecorr==28) {redcorr=1;greencorr=1;bluecorr=0;}
	else if (redcorr==60 && greencorr==57 && bluecorr==45) {redcorr=2;greencorr=2;bluecorr=2;}
	else if (redcorr==59 && greencorr==49 && bluecorr==41) {redcorr=3;greencorr=2;bluecorr=2;}
	else if (redcorr==53 && greencorr==59 && bluecorr==46) {redcorr=6;greencorr=6;bluecorr=5;}
	else if (redcorr==55 && greencorr==59 && bluecorr==55) {redcorr=4;greencorr=4;bluecorr=4;}
	else if (redcorr==50 && greencorr==53 && bluecorr==46) {redcorr=3;greencorr=3;bluecorr=2;}
	else if (redcorr==36 && greencorr==38 && bluecorr==27) {redcorr=1;greencorr=1;bluecorr=1;}
	else if (redcorr==54 && greencorr==51 && bluecorr==48) {redcorr=3;greencorr=3;bluecorr=3;}
	else if (redcorr==68 && greencorr==65 && bluecorr==59) {redcorr=0;greencorr=0;bluecorr=0;}
	else if (redcorr==49 && greencorr==45 && bluecorr==49) {redcorr=5;greencorr=4;bluecorr=5;}
	else if (redcorr==44 && greencorr==38 && bluecorr==32) {redcorr=4;greencorr=4;bluecorr=3;}
	else if (redcorr==46 && greencorr==41 && bluecorr==37) {redcorr=1;greencorr=1;bluecorr=1;}
	else if (redcorr==55 && greencorr==50 && bluecorr==44) {redcorr=5;greencorr=5;bluecorr=4;}
	else if (redcorr==52 && greencorr==48 && bluecorr==42) {redcorr=5;greencorr=4;bluecorr=4;}
	else if (redcorr==41 && greencorr==42 && bluecorr==44) {redcorr=2;greencorr=2;bluecorr=2;}
	else if (redcorr==57 && greencorr==50 && bluecorr==37) {redcorr=3;greencorr=3;bluecorr=2;}
	else if (redcorr==46 && greencorr==47 && bluecorr==47) {redcorr=1;greencorr=1;bluecorr=1;}
	else if (redcorr==43 && greencorr==29 && bluecorr==18) {redcorr=0;greencorr=0;bluecorr=0;}
	else if (redcorr==54 && greencorr==63 && bluecorr==53) {redcorr=1;greencorr=1;bluecorr=1;}
	else if (redcorr==52 && greencorr==57 && bluecorr==40) {redcorr=0;greencorr=0;bluecorr=0;}
	else if (redcorr==49 && greencorr==42 && bluecorr==34) {redcorr=4;greencorr=4;bluecorr=2;}
	else if (redcorr==42 && greencorr==32 && bluecorr==29) {redcorr=4;greencorr=3;bluecorr=2;}
	else if (redcorr==40 && greencorr==36 && bluecorr==29) {redcorr=4;greencorr=3;bluecorr=2;}
	else if (redcorr==46 && greencorr==44 && bluecorr==30) {redcorr=4;greencorr=4;bluecorr=3;}
	else if (redcorr==42 && greencorr==44 && bluecorr==46) {redcorr=2;greencorr=2;bluecorr=2;}
// the guild
	else if (redcorr==55 && greencorr==56 && bluecorr==47) {redcorr=3;greencorr=3;bluecorr=3;}//0 
	else if (redcorr==61 && greencorr==64 && bluecorr==52) {redcorr=5;greencorr=5;bluecorr=3;}// 15
	else {
		redcorr=greencorr=bluecorr=1;
	}
		redcorr=greencorr=bluecorr=1;
	for (i=0;i<picture->height;i++)
	{
		accuy+=rows;
		if (accuy>=picture->height || i==picture->height-1)
		{
			accuy-=picture->height;
			y_down=i+1;
			x_left=0;
			for (j=0;j<picture->width;j++)
			{
				accux+=cols;
				if (accux>=picture->width || j==picture->width-1)
				{
					x_right=j+1;
					accux-=picture->width;		
					red=green=blue=0;
					cnt2=0;
					for (k=y_up;k<y_down;k++)
					{
						for (l=x_left;l<x_right;l++)
						{
							if (cnt2<(cnt-1))
							{
								p=picture->pixels[k*picture->width+l];
								red+=(picture->palette[p]>>8)&0x7;	// red
								green+=(picture->palette[p]>>4)&0x7;	// green
								blue+=(picture->palette[p]>>0)&0x7;	// blue
								cnt2++;
							}
						}
					}
					red*=100;
					green*=100;
					blue*=100;
					red/=(cnt2+redcorr);
					green/=(cnt2+greencorr);
					blue/=(cnt2+bluecorr);
					red/=100;
					green/=100;
					blue/=100;
					
				
					// sooooo.. what i am trying in the next few lines is to 
					// come up with a character that approximates the rectangle
					// between y_up,x_left and y_down,x_right.
					//
					// I an looking at the extreme points, and count how similiar they
					// are. that gives me an indication which character i could use.	
					l=0;
					for (k=0;k<16;k++)
					{
						char p1,p2,p3,p4;
						int x1,x2,y1,y2;
						if ((k>>0)&1) y1=y_down;  else y1=y_up;
						if ((k>>1)&1) x1=x_right; else x1=x_left;
						if ((k>>2)&1) y2=y_down;  else y2=y_up;
						if ((k>>3)&1) x2=x_right; else x2=x_left;
						if ((x1!=x2 || y1!=y2) && (picture->pixels[y1*picture->width+x1]==picture->pixels[y2*picture->width+x2])) l++;
					}
					c=similar[l];
					if ((red==blue) && (red==green))        // all colors have the same intensity. so: grey scale                    
					{       
						if (red==0) col=0;   // black                                                
						else if (red>0 && red<2) col=8;   // dark grey                                    
						else if (red>=2 && red<4) col=7;  // light grey;
						else col=15;  // bright white                                         

					} else if (red>green && red>blue) {     // red is the most intense color
						if (red<4) col=1;    // dark red                                             
						else col=9;          // bright red                                           

					} else if (green>red && green>blue) {   // green is the most intense color              
						if (green<3) col=2;  // dark green
						else col=10;         // bright green
					} else if (blue>red && blue>green) {    // blue is the most intense color               
						if (blue<3) col=4;   // dark blue
						else col=12;         // bright blue
					} else if (red==green)  // brown or yellow                                              
					{               
						if (red<4) col=3;  
						else col=11;                                                                 
					} else if (red==blue)   // magenta                                                      
					{
						if (red<3) col=5;
						else col=13;                                                                 
					} else if (green==blue) // cyan
					{                                                                                       
						if (green<3) col=6;                                                          
						else col=14;
					}
					printf("\x1b[%d;3%dm%c",col/8,col%8,c);

					x_left=x_right;
				}
			}
			y_up=y_down;
			printf("\x1b[0m\n");
		}
	}

}
int default_render_monochrome(tPicture* picture,int rows,int cols)
{
	int i;
	int j;
	int k,l;

	int y_up,y_down,x_left,x_right;
	int accux,accuy;
	int grey;
	int mingrey,maxgrey;
	int cnt;
	int cnt2;
	int p;
	const unsigned char greyscales[14]=" .:-=+*x#/@$X";	// those characters increase in density.
	const int scalenum=13;
	accux=accuy=0;
	mingrey=maxgrey=0;
	// first: try to find the brightest/darkest pixels
	
	y_up=0;
	cnt=0;
	for (i=0;i<picture->height;i++)
	{
		accuy+=rows;
		if (accuy>=picture->height || i==picture->height-1)
		{
			accuy-=picture->height;
			y_down=i+1;
			x_left=0;
			for (j=0;j<picture->width;j++)
			{
				accux+=cols;
				if (accux>=picture->width || j==picture->width-1)
				{
					x_right=j+1;
					accux-=picture->width;		
					// at this point, a rectangle between y_up,y_down, x_left,x_right contains the pixels that need to be greyscaled.
					grey=0;
					cnt2=0;
					for (k=y_up;k<y_down;k++)
					{
						for (l=x_left;l<x_right;l++)
						{
							p=picture->pixels[k*picture->width+l];
							grey+=(picture->palette[p]>>8)&0x7;	// red
							grey+=(picture->palette[p]>>4)&0x7;	// green
							grey+=(picture->palette[p]>>0)&0x7;	// blue
							cnt2++;
						}
					}
					grey/=cnt2;
						
					if (cnt==0 || grey>maxgrey) maxgrey=grey;
					if (cnt==0 || grey<mingrey) mingrey=grey;
					cnt++;
					x_left=x_right;
				}
			}
			y_up=y_down;
		}
	}
	// mingrey is the lowest grey scale value.
	// maxgrey is the highest one.


	y_up=0;
	accuy=0;
	for (i=0;i<picture->height;i++)
	{
		accuy+=rows;
		if (accuy>=picture->height || i==picture->height-1)
		{
			accuy-=picture->height;
			y_down=i+1;
			x_left=0;
			for (j=0;j<picture->width;j++)
			{
				accux+=cols;
				if (accux>=picture->width || j==picture->width-1)
				{
					x_right=j+1;
					accux-=picture->width;
					
					// at this point, a rectangle between y_up,y_down, x_left,x_right contains the pixels that need to be greyscaled.
					grey=0;
					cnt2=0;
					for (k=y_up;k<y_down;k++)
					{
						for (l=x_left;l<x_right;l++)
						{
							p=picture->pixels[k*picture->width+l];
							grey+=(picture->palette[p]>>8)&0x7;	// red
							grey+=(picture->palette[p]>>4)&0x7;	// green
							grey+=(picture->palette[p]>>0)&0x7;	// blue
							cnt2++;
						}
					}
					grey/=cnt2;
					grey-=mingrey;
					grey*=(scalenum-1);
					grey/=(maxgrey-mingrey);
					printf("%c",greyscales[grey]);
					x_left=x_right;
				}
			}
			y_up=y_down;
			printf("\n");
		}
	}
	return 0;
}

